#ifndef TIMING
#define TIMING

#include <vector>
#include <iostream>
#include <unordered_map>
#include <string>

class Timing{
private:
	std::unordered_map<std::string, std::vector<float>> timings;
	std::vector< float > total;
	int dim = 0;
public:

	void insert( std::string& s, float t ) {
		if( timings.find(s) == timings.end() ) {
			timings[s] = std::vector<float>();
		}
		timings[s].push_back( t );
		dim = std::max( (int)timings[s].size(), dim );
	}

	void insert( const char* s, float t ) {
		if( timings.find(s) == timings.end() ) {
			timings[s] = std::vector<float>();
		}

		timings[s].push_back( t );
		dim = std::max( (int)timings[s].size(), dim );
	}

	void compTotal() {
		int i=0;
		float tot=0;

		while( i < dim ) {
			for( auto k : timings ) {
				tot += k.second[i];
			}
			total.push_back( tot );
			++i;
		}
	}

	void print( int d ) {
		for( auto k : timings ) {
			std::cout << k.first << " : " << k.second[d] << std::endl;
		}
	}

	void printAll() {
		for( auto k : timings ) {
			std::cout << k.first << " : ";
			for( auto l : k.second ) {
				std::cout << l << " ";
			}
			std::cout << std::endl;
		}
	}

	void printTot( int d ) {
		if( total.size() == 0 ) compTotal();
		std::cout << total[d] << std::endl;
	}

	void printTotAll( ) {
		if( total.size() == 0 ) compTotal();
		for( auto t : total ) {
			std::cout << t << " ";
		}
		std::cout << std::endl;
	}
};
#endif